osgParticle::ForceOperator Class Reference

`#include <ForceOperator>`

Inheritance diagram for osgParticle::ForceOperator:

## Public Member Functions

| ForceOperator ()
| ForceOperator (const ForceOperator &copy, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgParticle, ForceOperator)
const osg::Vec3 & | getForce () const
| Get the force vector.
void | setForce (const osg::Vec3 &f)
| Set the force vector.
void | operate (Particle *P, double dt)
| Apply the force to a particle. Do not call this method manually.
void | beginOperate (Program *prg)
| Perform some initialization. Do not call this method manually.
Public Member Functions inherited from osgParticle::Operator
| Operator ()
| Operator (const Operator &copy, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
virtual const char * | libraryName () const
virtual const char * | className () const
virtual bool | isSameKindAs (const osg::Object *obj) const
bool | isEnabled () const
| Get whether this operator is enabled.
void | setEnabled (bool v)
| Enable or disable this operator.
virtual void | operateParticles (ParticleSystem *ps, double dt)
virtual void | endOperate ()
| Do something after all particles have been processed.
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~ForceOperator ()
ForceOperator & | operator= (const ForceOperator &)
Protected Member Functions inherited from osgParticle::Operator
virtual | ~Operator ()
Operator & | operator= (const Operator &)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Detailed Description

An operator that applies a constant force to the particles. Remember that if the mass of particles is expressed in kg and the lengths are expressed in meters, then the force should be expressed in Newtons.

## Constructor & Destructor Documentation

## ForceOperator() [1/2]

osgParticle::ForceOperator::ForceOperator | ( |  | ) |

inline

References osgParticle::Operator::Operator().

Referenced by ForceOperator(), META_Object(), and operator=().

## ForceOperator() [2/2]

osgParticle::ForceOperator::ForceOperator | ( | const ForceOperator & | copy,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

inline

References ForceOperator(), and osgParticle::Operator::Operator().

## ~ForceOperator()

virtual osgParticle::ForceOperator::~ForceOperator | ( |  | ) |

inline protected virtual

## Member Function Documentation

## beginOperate()

void osgParticle::ForceOperator::beginOperate | ( | Program * | prg | ) |

inline virtual

Perform some initialization. Do not call this method manually.

Reimplemented from osgParticle::Operator.

References osgParticle::ParticleProcessor::getReferenceFrame(), osgParticle::ParticleProcessor::RELATIVE_RF, and osgParticle::ParticleProcessor::rotateLocalToWorld().

## getForce()

const osg::Vec3 & osgParticle::ForceOperator::getForce | ( |  | ) | const

inline

Get the force vector.

## META_Object()

osgParticle::ForceOperator::META_Object | ( | osgParticle | ,
|  | ForceOperator | )

References ForceOperator().

## operate()

void osgParticle::ForceOperator::operate | ( | Particle * | P,
|  | double | dt )

inline virtual

Apply the force to a particle. Do not call this method manually.

Implements osgParticle::Operator.

References osgParticle::Particle::addVelocity(), and osgParticle::Particle::getMassInv().

## operator=()

ForceOperator & osgParticle::ForceOperator::operator= | ( | const ForceOperator & |  | ) |

inline protected

References ForceOperator().

## setForce()

void osgParticle::ForceOperator::setForce | ( | const osg::Vec3 & | f | ) |

inline

Set the force vector.

The documentation for this class was generated from the following file:

- ForceOperator